/* global $ */

// register page js
$(function () {
  // auto-render profile url on user changes
  var usernameInput = $('#input-username')
  var usernameOutput = $('#output-username')
  output()
  usernameInput.on('keyup', output)
  function output () {
    usernameOutput.text(usernameInput.val() || 'username')
  }

  $('.form-register').on('submit', function (e) {
    e.preventDefault()

    // serialize form values
    var values = {}
    $(this).serializeArray().forEach(function (value) {
      values[value.name] = value.value
    })

    // post to api
    var jqxhr = $.post('/v1/register', values)
    jqxhr.done(function (res) {
      // success, redirect
      window.location = '/registered?email=' + escape(values.email)
    })
    jqxhr.fail(function (res) {
      // failure, render errors
      renderErrors(res.responseJSON)
    })
  })

  function renderErrors (json) {
    // general error
    $('#error-general').text(json.message)

    // individual form errors
    var details = json.details || {}
    ;(['username', 'email', 'password']).forEach(function (name) {
      if (details[name]) {
        $('#error-' + name)
          .text(details[name].msg)
          .parent()
          .addClass('has-warning')
      } else {
        $('#error-' + name)
          .text('')
          .parent()
          .removeClass('has-warning')
      }
    })
  }
})
